Package org.optaplanner.core.impl.heuristic.selector.move.generic.chained

## Class SubChainChangeMoveSelector<Solution_>

- java.lang.Object
- - org.optaplanner.core.impl.heuristic.selector.AbstractSelector<Solution_>
  - - org.optaplanner.core.impl.heuristic.selector.move.AbstractMoveSelector<Solution_>
    - - org.optaplanner.core.impl.heuristic.selector.move.generic.GenericMoveSelector<Solution_>
      - - org.optaplanner.core.impl.heuristic.selector.move.generic.chained.SubChainChangeMoveSelector<Solution_>

- All Implemented Interfaces:
    `Iterable<Move<Solution_>>`, `EventListener`, `IterableSelector<Solution_,​Move<Solution_>>`, `MoveSelector<Solution_>`, `Selector<Solution_>`, `PhaseLifecycleListener<Solution_>`, `SolverLifecycleListener<Solution_>`

      public class SubChainChangeMoveSelector<Solution_>
      extends GenericMoveSelector<Solution_>

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected SingletonInverseVariableSupply` | `inverseVariableSupply` |
    `protected boolean` | `randomSelection` |
    `protected boolean` | `selectReversingMoveToo` |
    `protected SubChainSelector<Solution_>` | `subChainSelector` |
    `protected EntityIndependentValueSelector<Solution_>` | `valueSelector` |

    - ### Fields inherited from class org.optaplanner.core.impl.heuristic.selector.AbstractSelector

      `logger, phaseLifecycleSupport, workingRandom`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `SubChainChangeMoveSelector​(SubChainSelector<Solution_> subChainSelector, EntityIndependentValueSelector<Solution_> valueSelector, boolean randomSelection, boolean selectReversingMoveToo)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `long` | `getSize()` | A random JIT `Selector` with `Selector.isNeverEnding()` true should return a size as if it would be able to return each distinct element only once, because the size can be used in `SelectionProbabilityWeightFactory`.
    `boolean` | `isCountable()` | If false, then `Selector.isNeverEnding()` is true.
    `boolean` | `isNeverEnding()` | Is true if `Selector.isCountable()` is false or if this selector is in random order (for most cases).
    `Iterator<Move<Solution_>>` | `iterator()` |
    `void` | `solvingEnded​(SolverScope<Solution_> solverScope)` |
    `void` | `solvingStarted​(SolverScope<Solution_> solverScope)` |
    `String` | `toString()` |

    - ### Methods inherited from class org.optaplanner.core.impl.heuristic.selector.AbstractSelector

      `getCacheType, phaseEnded, phaseStarted, stepEnded, stepStarted`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach`

    - ### Methods inherited from interface org.optaplanner.core.impl.heuristic.selector.IterableSelector

      `spliterator`

    - ### Methods inherited from interface org.optaplanner.core.impl.heuristic.selector.move.MoveSelector

      `supportsPhaseAndSolverCaching`

    - ### Methods inherited from interface org.optaplanner.core.impl.phase.event.PhaseLifecycleListener

      `phaseEnded, phaseStarted, stepEnded, stepStarted`

    - ### Methods inherited from interface org.optaplanner.core.impl.heuristic.selector.Selector

      `getCacheType`

- - ### Field Detail

    - #### subChainSelector

          protected final SubChainSelector<Solution_> subChainSelector

    - #### valueSelector

          protected final EntityIndependentValueSelector<Solution_> valueSelector

    - #### randomSelection

          protected final boolean randomSelection

    - #### selectReversingMoveToo

          protected final boolean selectReversingMoveToo

    - #### inverseVariableSupply

          protected SingletonInverseVariableSupply inverseVariableSupply

  - ### Constructor Detail

    - #### SubChainChangeMoveSelector

          public SubChainChangeMoveSelector​(SubChainSelector<Solution_> subChainSelector,
                                            EntityIndependentValueSelector<Solution_> valueSelector,
                                            boolean randomSelection,
                                            boolean selectReversingMoveToo)

  - ### Method Detail

    - #### solvingStarted

          public void solvingStarted​(SolverScope<Solution_> solverScope)

      Specified by:
        `solvingStarted` in interface `SolverLifecycleListener<Solution_>`
      Overrides:
        `solvingStarted` in class `AbstractSelector<Solution_>`

    - #### solvingEnded

          public void solvingEnded​(SolverScope<Solution_> solverScope)

      Specified by:
        `solvingEnded` in interface `SolverLifecycleListener<Solution_>`
      Overrides:
        `solvingEnded` in class `AbstractSelector<Solution_>`

    - #### isCountable

          public boolean isCountable()

      Description copied from interface: `Selector`
      If false, then `Selector.isNeverEnding()` is true.
      Returns:
        true if all the `ValueRange`s are countable (for example a double value range between 1.2 and 1.4 is not countable)

    - #### isNeverEnding

          public boolean isNeverEnding()

      Description copied from interface: `Selector`
      Is true if `Selector.isCountable()` is false or if this selector is in random order (for most cases). Is never true when this selector is in shuffled order (which is less scalable but more exact).
      Returns:
        true if the `Iterator.hasNext()` of the `Iterator` created by `Iterable.iterator()` never returns false (except when it's empty).

    - #### getSize

          public long getSize()

      Description copied from interface: `IterableSelector`
      A random JIT `Selector` with `Selector.isNeverEnding()` true should return a size as if it would be able to return each distinct element only once, because the size can be used in `SelectionProbabilityWeightFactory`.
      Returns:
        the approximate number of elements generated by this `Selector`, always `>= 0`

    - #### iterator

          public Iterator<Move<Solution_>> iterator()

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`